org.apache.ignite.internal.util.future

## Class GridFutureAdapter<R>

- java.lang.Object
- - java.util.concurrent.locks.AbstractOwnableSynchronizer
  - - java.util.concurrent.locks.AbstractQueuedSynchronizer
    - - org.apache.ignite.internal.util.future.GridFutureAdapter<R>

All Implemented Interfaces:
  Serializable, IgniteInternalFuture<R>

Direct Known Subclasses:
  ComputeTaskInternalFuture, GridCacheMultiTxFuture, GridCacheQueryFutureAdapter, GridCompoundFuture, GridDhtAssignmentFetchFuture, GridDhtAtomicUpdateFuture, GridDhtPartitionsExchangeFuture, GridEmbeddedFuture, GridLocalLockFuture, GridNearAtomicUpdateFuture, GridNioFutureImpl, GridServiceDeploymentFuture, GridWorkerFuture

    public class GridFutureAdapter<R>
    extends AbstractQueuedSynchronizer
    implements IgniteInternalFuture<R>

Future adapter.

See Also:
  Serialized Form

### Nested Class Summary

### Nested classes/interfaces inherited from class java.util.concurrent.locks.AbstractQueuedSynchronizer

`AbstractQueuedSynchronizer.ConditionObject`

### Constructor Summary

Constructors
Constructor and Description
`GridFutureAdapter()`

### Method Summary

Methods
`boolean` `cancel()` Default no-op implementation that always returns `false`.
`<T> IgniteInternalFuture<T>` `chain(IgniteClosure<? super IgniteInternalFuture<R>,T> doneCb)` Make a chained future to convert result of this future (when complete) into a new format.
`long` `duration()` Gets duration in milliseconds between start of the future and current time if future is not finished, or between start and finish of this future.
`long` `endTime()`
`Throwable` `error()`
`R` `get()` Synchronously waits for completion of the computation and returns computation result.
`R` `get(long timeout)` Synchronously waits for completion of the computation for up to the timeout specified and returns computation result.
`R` `get(long timeout, TimeUnit unit)` Synchronously waits for completion of the computation for up to the timeout specified and returns computation result.
`protected R` `get0(long nanosTimeout)`
`boolean` `isCancelled()` Returns `true` if this computation was cancelled before it completed normally.
`boolean` `isDone()` Checks if computation is done.
`boolean` `isFailed()`
`void` `listen(IgniteInClosure<? super IgniteInternalFuture<R>> lsnr0)` Registers listener closure to be asynchronously notified whenever future completes.
`boolean` `onCancelled()` Callback to notify that future is cancelled.
`boolean` `onDone()` Callback to notify that future is finished with `null` result.
`boolean` `onDone(R res)` Callback to notify that future is finished.
`boolean` `onDone(R res, Throwable err)` Callback to notify that future is finished.
`boolean` `onDone(Throwable err)` Callback to notify that future is finished.
`R` `result()`
`long` `startTime()` Gets start time for this future.
`String` `toString()`
`protected int` `tryAcquireShared(int ignore)`
`protected boolean` `tryReleaseShared(int ignore)`

### Methods inherited from class java.util.concurrent.locks.AbstractQueuedSynchronizer

`acquire, acquireInterruptibly, acquireShared, acquireSharedInterruptibly, compareAndSetState, getExclusiveQueuedThreads, getFirstQueuedThread, getQueuedThreads, getQueueLength, getSharedQueuedThreads, getState, getWaitingThreads, getWaitQueueLength, hasContended, hasQueuedPredecessors, hasQueuedThreads, hasWaiters, isHeldExclusively, isQueued, owns, release, releaseShared, setState, tryAcquire, tryAcquireNanos, tryAcquireSharedNanos, tryRelease`

### Methods inherited from class java.util.concurrent.locks.AbstractOwnableSynchronizer

`getExclusiveOwnerThread, setExclusiveOwnerThread`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Constructor Detail

#### GridFutureAdapter

    public GridFutureAdapter()

### Method Detail

#### startTime

    public long startTime()

Gets start time for this future.

Specified by:
  `startTime` in interface `IgniteInternalFuture<R>`
Returns:
  Start time for this future.

#### duration

    public long duration()

Gets duration in milliseconds between start of the future and current time if future is not finished, or between start and finish of this future.

Specified by:
  `duration` in interface `IgniteInternalFuture<R>`
Returns:
  Time in milliseconds this future has taken to execute.

#### endTime

    public long endTime()

Returns:
  Future end time.

#### error

    public Throwable error()

Specified by:
  `error` in interface `IgniteInternalFuture<R>`
Returns:
  Error value if future has already been completed with error.

#### result

    public R result()

Specified by:
  `result` in interface `IgniteInternalFuture<R>`
Returns:
  Result value if future has already been completed normally.

#### get

    public R get()
          throws IgniteCheckedException

Synchronously waits for completion of the computation and returns computation result.

Specified by:
  `get` in interface `IgniteInternalFuture<R>`
Returns:
  Computation result.
Throws:
  `IgniteInterruptedCheckedException` - Subclass of `IgniteCheckedException` thrown if the wait was interrupted.
  `IgniteFutureCancelledCheckedException` - Subclass of `IgniteCheckedException` throws if computation was cancelled.
  `IgniteCheckedException` - If computation failed.

#### get

    public R get(long timeout)
          throws IgniteCheckedException

Synchronously waits for completion of the computation for up to the timeout specified and returns computation result. This method is equivalent to calling `get(long, TimeUnit.MILLISECONDS)`.

Specified by:
  `get` in interface `IgniteInternalFuture<R>`
Parameters:
  `timeout` - The maximum time to wait in milliseconds.
Returns:
  Computation result.
Throws:
  `IgniteInterruptedCheckedException` - Subclass of `IgniteCheckedException` thrown if the wait was interrupted.
  `IgniteFutureTimeoutCheckedException` - Subclass of `IgniteCheckedException` thrown if the wait was timed out.
  `IgniteFutureCancelledCheckedException` - Subclass of `IgniteCheckedException` throws if computation was cancelled.
  `IgniteCheckedException` - If computation failed.

#### get

    public R get(long timeout,
        TimeUnit unit)
          throws IgniteCheckedException

Synchronously waits for completion of the computation for up to the timeout specified and returns computation result.

Specified by:
  `get` in interface `IgniteInternalFuture<R>`
Parameters:
  `timeout` - The maximum time to wait.
  `unit` - The time unit of the `timeout` argument.
Returns:
  Computation result.
Throws:
  `IgniteInterruptedCheckedException` - Subclass of `IgniteCheckedException` thrown if the wait was interrupted.
  `IgniteFutureTimeoutCheckedException` - Subclass of `IgniteCheckedException` thrown if the wait was timed out.
  `IgniteFutureCancelledCheckedException` - Subclass of `IgniteCheckedException` throws if computation was cancelled.
  `IgniteCheckedException` - If computation failed.

#### get0

    @Nullable
    protected R get0(long nanosTimeout)
              throws InterruptedException,
                     IgniteCheckedException

Parameters:
  `nanosTimeout` - Timeout (nanoseconds).
Returns:
  Result.
Throws:
  `InterruptedException` - If interrupted.
  `IgniteFutureTimeoutCheckedException` - If timeout reached before computation completed.
  `IgniteCheckedException` - If error occurred.

#### listen

    public void listen(IgniteInClosure<? super IgniteInternalFuture<R>> lsnr0)

Registers listener closure to be asynchronously notified whenever future completes.

Specified by:
  `listen` in interface `IgniteInternalFuture<R>`
Parameters:
  `lsnr0` - Listener closure to register. If not provided - this method is no-op.

#### chain

    public <T> IgniteInternalFuture<T> chain(IgniteClosure<? super IgniteInternalFuture<R>,T> doneCb)

Make a chained future to convert result of this future (when complete) into a new format. It is guaranteed that done callback will be called only ONCE.

Specified by:
  `chain` in interface `IgniteInternalFuture<R>`
Parameters:
  `doneCb` - Done callback that is applied to this future when it finishes to produce chained future result.
Returns:
  Chained future that finishes after this future completes and done callback is called.

#### cancel

    public boolean cancel()
                   throws IgniteCheckedException

Default no-op implementation that always returns `false`. Futures that do support cancellation should override this method and call `onCancelled()` callback explicitly if cancellation indeed did happen.

Specified by:
  `cancel` in interface `IgniteInternalFuture<R>`
Returns:
  `True` if future was canceled (i.e. was not finished prior to this call).
Throws:
  `IgniteCheckedException` - If cancellation failed.

#### isDone

    public boolean isDone()

Checks if computation is done.

Specified by:
  `isDone` in interface `IgniteInternalFuture<R>`
Returns:
  `True` if computation is done, `false` otherwise.

#### isFailed

    public boolean isFailed()

Returns:
  Checks is future is completed with exception.

#### isCancelled

    public boolean isCancelled()

Returns `true` if this computation was cancelled before it completed normally.

Specified by:
  `isCancelled` in interface `IgniteInternalFuture<R>`
Returns:
  `True` if this computation was cancelled before it completed normally.

#### onDone

    public final boolean onDone()

Callback to notify that future is finished with `null` result. This method must delegate to `onDone(Object, Throwable)` method.

Returns:
  `True` if result was set by this call.

#### onDone

    public final boolean onDone(@Nullable
                 R res)

Callback to notify that future is finished. This method must delegate to `onDone(Object, Throwable)` method.

Parameters:
  `res` - Result.
Returns:
  `True` if result was set by this call.

#### onDone

    public final boolean onDone(@Nullable
                 Throwable err)

Callback to notify that future is finished. This method must delegate to `onDone(Object, Throwable)` method.

Parameters:
  `err` - Error.
Returns:
  `True` if result was set by this call.

#### onDone

    public boolean onDone(@Nullable
                 R res,
                 @Nullable
                 Throwable err)

Callback to notify that future is finished. Note that if non-`null` exception is passed in the result value will be ignored.

Parameters:
  `res` - Optional result.
  `err` - Optional error.
Returns:
  `True` if result was set by this call.

#### onCancelled

    public boolean onCancelled()

Callback to notify that future is cancelled.

Returns:
  `True` if cancel flag was set by this call.

#### tryAcquireShared

    protected final int tryAcquireShared(int ignore)

Overrides:
  `tryAcquireShared` in class `AbstractQueuedSynchronizer`

#### tryReleaseShared

    protected final boolean tryReleaseShared(int ignore)

Overrides:
  `tryReleaseShared` in class `AbstractQueuedSynchronizer`

#### toString

    public String toString()

Overrides:
  `toString` in class `AbstractQueuedSynchronizer`

2015 Copyright © Apache Software Foundation

Follow @ApacheIgnite

Ignite Fabric | : ver. 1.0.0
Release Date | : March 31 2015